diff --git a/src/src/routers/redirect.c b/src/src/routers/redirect.c
index 6d0574c14..e90ad2147 100644
--- a/src/src/routers/redirect.c
+++ b/src/src/routers/redirect.c
@@ -804,7 +804,7 @@ router_info redirect_router_info =
   .options_block =	&redirect_router_option_defaults,
   .options_len =	sizeof(redirect_router_options_block),
   .init =		redirect_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_REDIRECT==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index b5a054a16..e6c9dbacc 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -1780,10 +1780,7 @@ memset(sender_address_cache, 0, sizeof(sender_address_cache));
 memset(sender_domain_cache, 0, sizeof(sender_domain_cache));
 
 authenticated_sender = NULL;
-#ifdef EXPERIMENTAL_BRIGHTMAIL
- bmi_run = 0;
- bmi_verdicts = NULL;
-#endif
+dnslist_domain = dnslist_matched = NULL;
 
 dsn_ret = 0;
 dsn_envid = NULL;
diff --git a/src/src/spool_in.c b/src/src/spool_in.c
index ff9edfc2e..b475c3955 100644
--- a/src/src/spool_in.c
+++ b/src/src/spool_in.c
@@ -263,11 +263,6 @@ f.spool_file_wireformat = FALSE;
 #endif
 tree_nonrecipients = NULL;
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-bmi_run = 0;
-bmi_verdicts = NULL;
-#endif
-
 #ifndef DISABLE_DKIM
 f.dkim_disable_verify = FALSE;
 # ifdef COMPILE_UTILITY
@@ -615,10 +610,6 @@ for (;;)
       body_linecount = Uatoi(var + 14);
     else if (Ustrncmp(p, "ody_zerocount", 13) == 0)
       body_zerocount = Uatoi(var + 14);
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-    else if (Ustrncmp(p, "mi_verdicts ", 12) == 0)
-      bmi_verdicts = string_copy_taint(var + 13, proto_mem);
-#endif
     break;
 
     case 'd':
diff --git a/src/src/spool_out.c b/src/src/spool_out.c
index e5cded966..91b776df2 100644
--- a/src/src/spool_out.c
+++ b/src/src/spool_out.c
@@ -269,15 +269,12 @@ if (spam_score_int) spool_var_write(fp, US"spam_score_int", spam_score_int);
 if (f.deliver_manual_thaw) fprintf(fp, "-manual_thaw\n");
 if (f.sender_set_untrusted) fprintf(fp, "-sender_set_untrusted\n");
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-if (bmi_verdicts) spool_var_write(fp, US"bmi_verdicts", bmi_verdicts);
-#endif
-
 #ifndef DISABLE_TLS
 if (tls_in.certificate_verified) fprintf(fp, "-tls_certificate_verified\n");
 if (tls_in.cipher) spool_var_write(fp, US"tls_cipher", tls_in.cipher);
 if (tls_in.peercert)
   {
+  /* -- marks as tainted */
   if (tls_export_cert(big_buffer, big_buffer_size, tls_in.peercert))
     fprintf(fp, "--tls_peercert %s\n", CS big_buffer);
   }
diff --git a/src/src/structs.h b/src/src/structs.h
index 8f3eaacbf..147819dd5 100644
--- a/src/src/structs.h
+++ b/src/src/structs.h
@@ -153,6 +153,7 @@ typedef struct driver_instance {
 typedef struct driver_info {
   struct driver_info * next;
   uschar *driver_name;            /* Name of driver */
+  uschar *avail_string;		  /* if set, display rather than name */
 
   optionlist *options;            /* Table of private options names */
   int    *options_count;          /* -> Number of entries in table */
@@ -299,9 +300,6 @@ typedef struct router_instance {
   driver_instance drinst;
 
   uschar *address_data;           /* Arbitrary data */
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  uschar *bmi_rule;               /* Brightmail AntiSpam rule checking */
-#endif
   uschar *cannot_route_message;   /* Used when routing fails */
   uschar *condition;              /* General condition */
   uschar *current_directory;      /* For use during delivery */
@@ -330,11 +328,6 @@ typedef struct router_instance {
   uschar *transport_name;         /* Transport name */
 
   BOOL    address_test;           /* Use this router when testing addresses */
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  BOOL    bmi_deliver_alternate;  /* TRUE => BMI said that message should be delivered to alternate location */
-  BOOL    bmi_deliver_default;    /* TRUE => BMI said that message should be delivered to default location */
-  BOOL    bmi_dont_deliver;       /* TRUE => BMI said that message should not be delivered at all */
-#endif
   BOOL    expn;                   /* Use this router when processing EXPN */
   BOOL    caseful_local_part;     /* TRUE => don't lowercase */
   BOOL    check_local_user;       /* TRUE => check local user */
diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index 66359bb3e..80fb419d0 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -578,16 +578,23 @@ msg = rc == GNUTLS_E_FATAL_ALERT_RECEIVED
 
 (void) tls_error(when, msg, state->host, &errstr);
 
-if (state->host)
-  log_write(0, LOG_MAIN, "H=%s [%s] TLS error on connection %s",
-    state->host->name, state->host->address, errstr);
-else
+if (!state->host)
   {
   uschar * conn_info = smtp_get_connection_info();
   if (Ustrncmp(conn_info, US"SMTP ", 5) == 0) conn_info += 5;
   /* I'd like to get separated H= here, but too hard for now */
   log_write(0, LOG_MAIN, "TLS error on %s %s", conn_info, errstr);
   }
+else if (  !tls_out.smtp_quit
+#ifdef GNUTLS_E_PREMATURE_TERMINATION
+	|| rc != GNUTLS_E_PREMATURE_TERMINATION
+#endif
+	)
+  log_write(0, LOG_MAIN, "H=%s [%s] TLS error on connection %s",
+    state->host->name, state->host->address, errstr);
+else DEBUG(D_tls)
+  debug_printf("H=%s [%s] TLS error on connection %s\n",
+    state->host->name, state->host->address, errstr);
 }
 
 
@@ -3523,7 +3530,7 @@ if (gnutls_session_get_flags(session) & GNUTLS_SFLAGS_SESSION_TICKET)
       debug_printf(" extract session data: %s\n", US gnutls_strerror(rc));
       }
   else DEBUG(D_tls)
-      debug_printf(" host not resmable; not saving ticket\n");
+      debug_printf(" host not resumable; not saving ticket\n");
   }
 }
 
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index 66661e94e..d5a6d368d 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -509,6 +509,22 @@ return host ? FAIL : DEFER;
 }
 
 
+static void
+tls_debug_err(SSL * ssl, uschar * where, int rc)
+{
+BIO * bio = BIO_new(BIO_s_mem());
+char * buf = NULL;
+size_t len;
+int error = SSL_get_error(ssl, rc);
+
+ERR_error_string_n(ERR_peek_error(), ssl_errstring, sizeof(ssl_errstring));
+ERR_print_errors(bio);
+len = BIO_get_mem_data(bio, &buf);
+debug_printf("%s: error %d\n%.*s\n", where, error, (int)len, buf);
+BIO_free (bio);
+}
+
+
 
 /**************************************************
 * General library initalisation                   *
@@ -983,24 +999,24 @@ DEBUG(D_tls)
   if (where & SSL_CB_HANDSHAKE_DONE)  g = string_append_listele(g, ',', US"hshake_done");
 
   if (where & SSL_CB_LOOP)
-     debug_printf("SSL %s: %s\n", g->s, SSL_state_string_long(s));
+     debug_printf("SSL %Y: %s\n", g, SSL_state_string_long(s));
   else if (where & SSL_CB_ALERT)
-    debug_printf("SSL %s %s:%s\n", g->s,
+    debug_printf("SSL %Y %s:%s\n", g,
 	  SSL_alert_type_string_long(ret), SSL_alert_desc_string_long(ret));
   else if (where & SSL_CB_EXIT)
     {
     if (ret <= 0)
-      debug_printf("SSL %s: %s in %s\n", g->s,
+      debug_printf("SSL %Y: %s in %s\n", g,
 	ret == 0 ? "failed" : "error", SSL_state_string_long(s));
     }
   else if (where & (SSL_CB_HANDSHAKE_START | SSL_CB_HANDSHAKE_DONE))
-     debug_printf("SSL %s: %s\n", g->s, SSL_state_string_long(s));
+     debug_printf("SSL %Y: %s\n", g, SSL_state_string_long(s));
   }
 }
 
 #ifdef OPENSSL_HAVE_KEYLOG_CB
 static void
-keylog_callback(const SSL *ssl, const char *line)
+keylog_callback(const SSL * ssl, const char * line)
 {
 char * filename;
 FILE * fp;
@@ -4533,11 +4549,10 @@ static BOOL
 tls_refill(unsigned lim)
 {
 SSL * ssl = state_server.lib_state.lib_ssl;
-int error;
-int inbytes;
+int error, inbytes;
 
-DEBUG(D_tls) debug_printf("Calling SSL_read(%p, %p, %u)\n", ssl,
-  ssl_xfer_buffer, ssl_xfer_buffer_size);
+DEBUG(D_tls) debug_printf("Calling SSL_read(tls_refill %p, %p, %u)\n",
+  ssl, ssl_xfer_buffer, ssl_xfer_buffer_size);
 
 ERR_clear_error();
 if (smtp_receive_timeout > 0) ALARM(smtp_receive_timeout);
@@ -4579,8 +4594,9 @@ switch(error)
     uschar * conn_info = smtp_get_connection_info();
     if (Ustrncmp(conn_info, US"SMTP ", 5) == 0) conn_info += 5;
     /* I'd like to get separated H= here, but too hard for now */
-    ERR_error_string_n(ERR_get_error(), ssl_errstring, sizeof(ssl_errstring));
+    ERR_error_string_n(ERR_peek_error(), ssl_errstring, sizeof(ssl_errstring));
     log_write(0, LOG_MAIN, "TLS error (SSL_read): on %s %s", conn_info, ssl_errstring);
+    DEBUG(D_tls) tls_debug_err(ssl, US"SSL_read", inbytes);
     ssl_xfer_error = TRUE;
     return FALSE;
     }
@@ -4701,29 +4717,30 @@ Only used by the client-side TLS.
 */
 
 int
-tls_read(void * ct_ctx, uschar *buff, size_t len)
+tls_read(void * ct_ctx, uschar * buff, size_t len)
 {
 SSL * ssl = ct_ctx ? ((exim_openssl_client_tls_ctx *)ct_ctx)->ssl
 		  : state_server.lib_state.lib_ssl;
 int inbytes;
 int error;
 
-DEBUG(D_tls) debug_printf("Calling SSL_read(%p, %p, %u)\n", ssl,
-  buff, (unsigned int)len);
+DEBUG(D_tls) debug_printf("Calling SSL_read(tls_read %p, %p, %u)\n",
+  ssl, buff, (unsigned int)len);
 
 ERR_clear_error();
 inbytes = SSL_read(ssl, CS buff, len);
 error = SSL_get_error(ssl, inbytes);
 
-if (error == SSL_ERROR_ZERO_RETURN)
-  {
-  DEBUG(D_tls) debug_printf("Got SSL_ERROR_ZERO_RETURN\n");
-  return -1;
-  }
-else if (error != SSL_ERROR_NONE)
-  return -1;
+if (error == SSL_ERROR_NONE)
+  return inbytes;
 
-return inbytes;
+else DEBUG(D_tls)
+  if (error == SSL_ERROR_ZERO_RETURN)
+    debug_printf("Got SSL_ERROR_ZERO_RETURN\n");
+  else
+    tls_debug_err(ssl, US"SSL_read", inbytes);
+ERR_clear_error();
+return -1;
 }
 
 
@@ -4861,12 +4878,9 @@ if ((o_ctx ? tls_out.active.sock : tls_in.active.sock) < 0)
 tls_write(ct_ctx, NULL, 0, FALSE);	/* flush write buffer */
 
 HDEBUG(D_transport|D_tls|D_acl|D_v) debug_printf_indent("  SMTP(TLS shutdown)>>\n");
-rc = SSL_shutdown(ssl);
-if (rc < 0) DEBUG(D_tls)
-  {
-  ERR_error_string_n(ERR_get_error(), ssl_errstring, sizeof(ssl_errstring));
-  debug_printf("SSL_shutdown: %s\n", ssl_errstring);
-  }
+ERR_clear_error();
+if ((rc = SSL_shutdown(ssl)) < 0)
+  DEBUG(D_tls) tls_debug_err(ssl, US"SSL_shutdown", rc);
 }
 
 /*************************************************
@@ -4905,6 +4919,7 @@ if (do_shutdown > TLS_NO_SHUTDOWN)
 
   tls_write(ct_ctx, NULL, 0, FALSE);	/* flush write buffer */
 
+  ERR_clear_error();
   if (  (  do_shutdown >= TLS_SHUTDOWN_WONLY
 	|| (rc = SSL_shutdown(*sslp)) == 0	/* send "close notify" alert */
 	)
@@ -4919,11 +4934,7 @@ if (do_shutdown > TLS_NO_SHUTDOWN)
     ALARM_CLR(0);
     }
 
-  if (rc < 0) DEBUG(D_tls)
-    {
-    ERR_error_string_n(ERR_get_error(), ssl_errstring, sizeof(ssl_errstring));
-    debug_printf("SSL_shutdown: %s\n", ssl_errstring);
-    }
+  if (rc < 0) DEBUG(D_tls) tls_debug_err(*sslp, US"SSL_shutdown", rc);
   }
 
 if (!o_ctx)		/* server side */
diff --git a/src/src/tlscert-gnu.c b/src/src/tlscert-gnu.c
index 6bbea7516..43d362904 100644
--- a/src/src/tlscert-gnu.c
+++ b/src/src/tlscert-gnu.c
@@ -150,6 +150,7 @@ if ((ret = gnutls_x509_crt_get_issuer_dn(cert, CS cp, &siz))
     != GNUTLS_E_SHORT_MEMORY_BUFFER)
   return g_err("gi0", __FUNCTION__, ret);
 
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
 cp = store_get(siz, GET_TAINTED);
 if ((ret = gnutls_x509_crt_get_issuer_dn(cert, CS cp, &siz)) < 0)
   return g_err("gi1", __FUNCTION__, ret);
@@ -226,14 +227,15 @@ return algo < 0 ? NULL : string_copy(US gnutls_sign_get_name(algo));
 uschar *
 tls_cert_subject(void * cert, const uschar * mod)
 {
-uschar * cp = NULL;
+uschar * cp;
 int ret;
 size_t siz = 0;
 
-if ((ret = gnutls_x509_crt_get_dn(cert, CS cp, &siz))
+if ((ret = gnutls_x509_crt_get_dn(cert, NULL, &siz))
     != GNUTLS_E_SHORT_MEMORY_BUFFER)
   return g_err("gs0", __FUNCTION__, ret);
 
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
 cp = store_get(siz, GET_TAINTED);
 if ((ret = gnutls_x509_crt_get_dn(cert, CS cp, &siz)) < 0)
   return g_err("gs1", __FUNCTION__, ret);
@@ -262,6 +264,7 @@ ret = gnutls_x509_crt_get_extension_by_oid ((gnutls_x509_crt_t)cert,
 if (ret != GNUTLS_E_SHORT_MEMORY_BUFFER)
   return g_err("ge0", __FUNCTION__, ret);
 
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
 cp1 = store_get(siz*4 + 1, GET_TAINTED);
 
 ret = gnutls_x509_crt_get_extension_by_oid ((gnutls_x509_crt_t)cert,
@@ -317,6 +320,7 @@ for (int index = 0;; index++)
       return g_err("gs0", __FUNCTION__, ret);
     }
 
+  /*XXX we might want to distinguish ourcert from peercert (but this is safe) */
   ele = store_get(siz+1, GET_TAINTED);
   if ((ret = gnutls_x509_crt_get_subject_alt_name(
     (gnutls_x509_crt_t)cert, index, ele, &siz, NULL)) < 0)
@@ -347,7 +351,8 @@ tls_cert_ocsp_uri(void * cert, const uschar * mod)
 gnutls_datum_t uri;
 int ret;
 uschar sep = '\n';
-gstring * list = NULL;
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+gstring * list = string_get_tainted(0, GET_TAINTED);
 
 if (mod)
   if (*mod == '>' && *++mod) sep = *mod++;
@@ -381,7 +386,8 @@ tls_cert_crl_uri(void * cert, const uschar * mod)
 {
 int ret;
 uschar sep = '\n';
-gstring * list = NULL;
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+gstring * list = string_get_tainted(0, GET_TAINTED);
 
 if (mod)
   if (*mod == '>' && *++mod) sep = *mod++;
@@ -394,7 +400,7 @@ for (int index = 0;; index++)
     (gnutls_x509_crt_t)cert, index, NULL, &siz, NULL, NULL))
     {
     case GNUTLS_E_REQUESTED_DATA_NOT_AVAILABLE:
-      return string_from_gstring(list);
+      return gstring_length(list) > 0 ? string_from_gstring(list) : NULL;
     case GNUTLS_E_SHORT_MEMORY_BUFFER:
       break;
     default:
@@ -449,6 +455,7 @@ if ((ret = gnutls_x509_crt_get_fingerprint(cert, algo, NULL, &siz))
     != GNUTLS_E_SHORT_MEMORY_BUFFER)
   return g_err("gf0", __FUNCTION__, ret);
 
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
 cp = store_get(siz*3+1, GET_TAINTED);
 if ((ret = gnutls_x509_crt_get_fingerprint(cert, algo, cp, &siz)) < 0)
   return g_err("gf1", __FUNCTION__, ret);
diff --git a/src/src/tlscert-openssl.c b/src/src/tlscert-openssl.c
index cdac8f6b2..5e3ce22a4 100644
--- a/src/src/tlscert-openssl.c
+++ b/src/src/tlscert-openssl.c
@@ -213,7 +213,9 @@ uschar *
 tls_cert_issuer(void * cert, const uschar * mod)
 {
 uschar * cp = x509_name_copy(X509_get_issuer_name((X509 *)cert));
-return mod ? tls_field_from_dn(cp, mod) : cp;
+if (mod) cp = tls_field_from_dn(cp, mod);
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+return cp ? string_copy_taint(cp, GET_TAINTED) : cp;
 }
 
 uschar *
@@ -312,7 +314,9 @@ uschar *
 tls_cert_subject(void * cert, const uschar * mod)
 {
 uschar * cp = x509_name_copy(X509_get_subject_name((X509 *)cert));
-return mod ? tls_field_from_dn(cp, mod) : cp;
+if (mod) cp = tls_field_from_dn(cp, mod);
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+return cp ? string_copy_taint(cp, GET_TAINTED) : cp;
 }
 
 uschar *
@@ -345,6 +349,7 @@ M_ASN1_OCTET_STRING_print(bp, adata);
 /* binary data, DER encoded */
 /* just dump for now */
 len = BIO_get_mem_data(bp, &cp1);
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
 cp3 = cp2 = store_get(len*3+1, GET_TAINTED);
 
 while(len)
@@ -360,14 +365,13 @@ return cp3;
 uschar *
 tls_cert_subject_altname(void * cert, const uschar * mod)
 {
-gstring * list = NULL;
 STACK_OF(GENERAL_NAME) * san = (STACK_OF(GENERAL_NAME) *)
   X509_get_ext_d2i((X509 *)cert, NID_subject_alt_name, NULL, NULL);
 uschar osep = '\n';
-uschar * tag = US"";
-uschar * ele;
-int match = -1;
-int len;
+uschar * tag = US"", * ele;
+int match = -1,  len;
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+gstring * list = string_get_tainted(0, GET_TAINTED);
 
 if (!san) return NULL;
 
@@ -417,7 +421,7 @@ while (sk_GENERAL_NAME_num(san) > 0)
   }
 
 sk_GENERAL_NAME_free(san);
-return string_from_gstring(list);
+return gstring_length(list) > 0 ? string_from_gstring(list) : NULL;
 }
 
 uschar *
@@ -427,7 +431,8 @@ STACK_OF(ACCESS_DESCRIPTION) * ads = (STACK_OF(ACCESS_DESCRIPTION) *)
   X509_get_ext_d2i((X509 *)cert, NID_info_access, NULL, NULL);
 int adsnum = sk_ACCESS_DESCRIPTION_num(ads);
 uschar sep = '\n';
-gstring * list = NULL;
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+gstring * list = string_get_tainted(0, GET_TAINTED);
 
 if (mod)
   if (*mod == '>' && *++mod) sep = *mod++;
@@ -442,7 +447,7 @@ for (int i = 0; i < adsnum; i++)
       ASN1_STRING_length(ad->location->d.ia5));
   }
 sk_ACCESS_DESCRIPTION_free(ads);
-return string_from_gstring(list);
+return gstring_length(list) > 0 ? string_from_gstring(list) : NULL;
 }
 
 uschar *
@@ -453,7 +458,8 @@ STACK_OF(DIST_POINT) * dps = (STACK_OF(DIST_POINT) *)
     NULL, NULL);
 DIST_POINT * dp;
 uschar sep = '\n';
-gstring * list = NULL;
+/*XXX we might want to distinguish ourcert from peercert (but this is safe) */
+gstring * list = string_get_tainted(0, GET_TAINTED);
 
 if (mod)
   if (*mod == '>' && *++mod) sep = *mod++;
@@ -473,7 +479,7 @@ if (dps) for (int i = 0, dpsnum = sk_DIST_POINT_num(dps); i < dpsnum; i++)
 	  ASN1_STRING_length(np->d.uniformResourceIdentifier));
     }
 sk_DIST_POINT_free(dps);
-return string_from_gstring(list);
+return gstring_length(list) > 0 ? string_from_gstring(list) : NULL;
 }
 
 
diff --git a/src/src/transports/appendfile.c b/src/src/transports/appendfile.c
index ebf11b7f7..cad14b889 100644
--- a/src/src/transports/appendfile.c
+++ b/src/src/transports/appendfile.c
@@ -3343,12 +3343,23 @@ ret_panic:
 transport_info appendfile_transport_info = {
 .drinfo = {
   .driver_name =	US"appendfile",
+  .avail_string =	US" appendfile"
+# ifdef SUPPORT_MAILDIR
+			  "/maildir"
+# endif
+# ifdef SUPPORT_MAILSTORE
+			  "/mailstore"
+# endif
+# ifdef SUPPORT_MBX
+			  "/mbx"
+# endif
+			,
   .options =		appendfile_transport_options,
   .options_count =	&appendfile_transport_options_count,
   .options_block =	&appendfile_transport_option_defaults,	/* private options defaults */
   .options_len =	sizeof(appendfile_transport_options_block),
   .init =		appendfile_transport_init,
-# ifdef DYNLOOKUP
+# if TRANSPORT_APPENDFILE==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/autoreply.c b/src/src/transports/autoreply.c
index 62eb888d0..d9d9d7a9d 100644
--- a/src/src/transports/autoreply.c
+++ b/src/src/transports/autoreply.c
@@ -817,7 +817,7 @@ transport_info autoreply_transport_info = {
   .options_block =	&autoreply_transport_option_defaults,
   .options_len =	sizeof(autoreply_transport_options_block),
   .init =		autoreply_transport_init,
-# ifdef DYNLOOKUP
+# if TRANSPORT_AUTOREPLY==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/lmtp.c b/src/src/transports/lmtp.c
index 3403dce7a..322dfbb71 100644
--- a/src/src/transports/lmtp.c
+++ b/src/src/transports/lmtp.c
@@ -825,7 +825,7 @@ transport_info lmtp_transport_info = {
   .options_block =	&lmtp_transport_option_defaults,
   .options_len =	sizeof(lmtp_transport_options_block),
   .init =		lmtp_transport_init,
-# ifdef DYNLOOKUP
+# if TRANSPORT_LMTP==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/pipe.c b/src/src/transports/pipe.c
index 68036ce03..fd248113a 100644
--- a/src/src/transports/pipe.c
+++ b/src/src/transports/pipe.c
@@ -1142,7 +1142,7 @@ transport_info pipe_transport_info = {
   .options_block =	&pipe_transport_option_defaults,
   .options_len =	sizeof(pipe_transport_options_block),
   .init =		pipe_transport_init,
-# ifdef DYNLOOKUP
+# if TRANSPORT_PIPE==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/queuefile.c b/src/src/transports/queuefile.c
index 7ae71a8da..5bd02682e 100644
--- a/src/src/transports/queuefile.c
+++ b/src/src/transports/queuefile.c
@@ -300,7 +300,7 @@ transport_info queuefile_transport_info = {
   .options_block =	&queuefile_transport_option_defaults,
   .options_len =	sizeof(queuefile_transport_options_block),
   .init =		queuefile_transport_init,
-# ifdef DYNLOOKUP
+# if EXPERIMENTAL_QUEUEFILE==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index e9dc0957c..36b6370fd 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -2381,6 +2381,7 @@ if (continue_hostname && continue_proxy_cipher)
     if (write(0, "QUIT\r\n", 6) < 0)
       DEBUG(D_any) debug_printf("stupid compiler\n");
     close(0);
+    tls_out.active.sock = -1;
     continue_hostname = continue_proxy_cipher = NULL;
     f.continue_more = FALSE;
     continue_sequence = 1;	/* Ensure proper logging of non-cont-conn */
@@ -2882,6 +2883,7 @@ else
       if (write(0, "QUIT\r\n", 6) < 0)
 	DEBUG(D_any) debug_printf("stupid compiler\n");
       close(0);
+      tls_out.active.sock = -1;
       continue_hostname = continue_proxy_cipher = NULL;
       f.continue_more = FALSE;
       continue_sequence = 1;	/* Ensure proper logging of non-cont-conn */
@@ -3027,6 +3029,7 @@ if (  smtp_peer_options & OPTION_TLS
       sx->send_quit = FALSE;
       goto TLS_FAILED;
       }
+    tls_out.smtp_quit = FALSE;
     sx->send_tlsclose = TRUE;
 
 # ifdef TCP_FASTOPEN
@@ -3484,7 +3487,10 @@ FAILED:
 SEND_QUIT:
 
 if (sx->send_quit)
+  {
   (void)smtp_write_command(sx, SCMD_FLUSH, "QUIT\r\n");
+  tls_out.smtp_quit = TRUE;
+  }
 
 #ifndef DISABLE_TLS
 if (sx->cctx.tls_ctx)
@@ -4476,6 +4482,7 @@ else
       HDEBUG(D_transport|D_acl|D_v) debug_printf_indent("  SMTP(shutdown)>>\n");
       shutdown(sx->cctx.sock, SHUT_WR);	/* flush output buffer, with TCP FIN */
       }
+    tls_out.smtp_quit = TRUE;
     }
 
   if (smtp_peer_options & OPTION_CHUNKING && sx->cmd_count > 1)
@@ -5170,6 +5177,10 @@ if (sx->send_quit)
   {			/* Use _MORE to get QUIT in FIN segment */
   (void)smtp_write_command(sx, SCMD_MORE, "QUIT\r\n");
 #ifndef DISABLE_TLS
+  /* This flag is a custom hack to avoid logging, under GnuTLS, Google's
+  habit of just dropping the TCP conn (which violates TLS spec) */
+  tls_out.smtp_quit = TRUE;
+
   if (sx->cctx.tls_ctx && sx->send_tlsclose)
     {
 # ifdef EXIM_TCP_CORK	/* Use _CORK to get TLS Close Notify in FIN segment */
@@ -5357,6 +5368,7 @@ sx.outblock.cmd_count = 0;
 sx.outblock.authenticating = FALSE;
 
 (void)smtp_write_command(&sx, SCMD_FLUSH, "QUIT\r\n");
+tls_out.smtp_quit = TRUE;
 (void)smtp_read_response(&sx, buffer, sizeof(buffer), '2', ob->command_timeout);
 (void)close(cctx.sock);
 }
@@ -6545,7 +6557,7 @@ transport_info smtp_transport_info = {
   .options_block =	&smtp_transport_option_defaults,
   .options_len =	sizeof(smtp_transport_options_block),
   .init =		smtp_transport_init,
-# ifdef DYNLOOKUP
+# if TRANSPORT_SMTP==2
   .dyn_magic =		TRANSPORT_MAGIC,
 # endif
   },
diff --git a/src/src/transports/smtp.h b/src/src/transports/smtp.h
index df6c9e963..49e3c8b96 100644
--- a/src/src/transports/smtp.h
+++ b/src/src/transports/smtp.h
@@ -202,7 +202,7 @@ typedef struct {
 
   unsigned	avoid_option;
   uschar *	igquotstr;
-  uschar *	helo_data;
+  const uschar * helo_data;
 #ifdef EXPERIMENTAL_DSN_INFO
   uschar *	smtp_greeting;
   uschar *	helo_response;
diff --git a/src/src/utf8.c b/src/src/utf8.c
index c05853838..6cb104ddd 100644
--- a/src/src/utf8.c
+++ b/src/src/utf8.c
@@ -47,37 +47,40 @@ The *err string pointer should be null before the call
 Return NULL for error, with optional errstr pointer filled in
 */
 
-uschar *
+const uschar *
 string_domain_utf8_to_alabel(const uschar * utf8, uschar ** err)
 {
-uschar * s1, * s;
+const uschar * cs;
+uschar * t, * s;
 int rc;
 
 #ifdef SUPPORT_I18N_2008
 /* Avoid lowercasing plain-ascii domains */
 if (!string_is_utf8(utf8))
-  return string_copy(utf8);
+  return utf8;
 
 /* Only lowercase is accepted by the library call.  A pity since we lose
 any mixed-case annotation.  This does not really matter for a domain. */
   {
+  const uschar * cs1;
   uschar c;
-  for (s1 = s = US utf8; (c = *s1); s1++) if (!(c & 0x80) && isupper(c))
+  for (cs1 = cs = utf8; (c = *cs1); cs1++) if (!(c & 0x80) && isupper(c))
     {
     s = string_copy(utf8);
-    for (s1 = s + (s1 - utf8); (c = *s1); s1++) if (!(c & 0x80) && isupper(c))
-      *s1 = tolower(c);
+    for (t = s + (cs1 - utf8); (c = *t); t++) if (!(c & 0x80) && isupper(c))
+      *t = tolower(c);
+    cs = s;
     break;
     }
   }
-if ((rc = idn2_lookup_u8((const uint8_t *) s, &s1, IDN2_NFC_INPUT)) != IDN2_OK)
+if ((rc = idn2_lookup_u8((const uint8_t *) cs, &t, IDN2_NFC_INPUT)) != IDN2_OK)
   {
   if (err) *err = US idn2_strerror(rc);
   return NULL;
   }
 #else
 s = US stringprep_utf8_nfkc_normalize(CCS utf8, -1);
-if (  (rc = idna_to_ascii_8z(CCS s, CSS &s1, IDNA_ALLOW_UNASSIGNED))
+if (  (rc = idna_to_ascii_8z(CCS s, CSS &t, IDNA_ALLOW_UNASSIGNED))
    != IDNA_SUCCESS)
   {
   free(s);
@@ -86,9 +89,9 @@ if (  (rc = idna_to_ascii_8z(CCS s, CSS &s1, IDNA_ALLOW_UNASSIGNED))
   }
 free(s);
 #endif
-s = string_copy(s1);
-free(s1);
-return s;
+cs = string_copy(t);
+free(t);
+return cs;
 }
 
 
@@ -132,7 +135,7 @@ return s;
 /* the *err string pointer should be null before the call */
 
 
-uschar *
+const uschar *
 string_localpart_utf8_to_alabel(const uschar * utf8, uschar ** err)
 {
 size_t ucs4_len = 0;
@@ -141,7 +144,7 @@ size_t p_len;
 uschar * res;
 int rc;
 
-if (!string_is_utf8(utf8)) return string_copy(utf8);
+if (!string_is_utf8(utf8)) return utf8;
 
 p = (punycode_uint *) stringprep_utf8_to_ucs4(CCS utf8, -1, &ucs4_len);
 if (!p || !ucs4_len)
@@ -212,10 +215,10 @@ The *err string pointer should be null before the call.
 Return NULL on error, with (optional) errstring pointer filled in
 */
 
-uschar *
+const uschar *
 string_address_utf8_to_alabel(const uschar * utf8, uschar ** err)
 {
-uschar * l, * d;
+const uschar * l, * d;
 
 if (!*utf8) return string_copy(utf8);
 
diff --git a/src/src/utils/eximstats.src b/src/src/utils/eximstats.src
index 84b60ceaa..41912c1fb 100644
--- a/src/src/utils/eximstats.src
+++ b/src/src/utils/eximstats.src
@@ -1852,7 +1852,7 @@ EoText
 sub generate_parser {
   my $parser = '
   my($ip,$host,$email,$edomain,$domain,$thissize,$size,$old,$new);
-  my($tod,$m_hour,$m_min,$id,$flag,$extra,$length);
+  my($tod,$m_hour,$m_min,$id,$flag,$offset,$length);
   my($seconds,$queued,$rcpt_time,$local_domain);
   my $rej_id = 0;
   while (<$fh>) {
@@ -1865,72 +1865,68 @@ sub generate_parser {
     $length = length($_);
     next if ($length < 38);
     next unless /^
-		(\\d{4}\\-\\d\\d-\\d\\d\\s	# 1: YYYYMMDD HHMMSS
-			(\\d\\d)		# 2: HH
-			:
-			(\\d\\d)		# 3: MM
-			:\\d\\d
-		)
-		(\\.\\d+)?			# 4: subseconds
-		(\s[-+]\\d\\d\\d\\d)?		# 5: tz-offset
-		(\s\\[\\d+\\])?			# 6: pid
+		(\\d{4}\\-\\d\\d-\\d\\d\\s	# 1: YYYYMMDD HHMMSS	11
+			(\\d\\d)		# 2: HH			 2
+			:			#			 1
+			(\\d\\d)		# 3: MM			 2
+			:\\d\\d			#			 3
+		)					#	=	19
+		(\\.\\d+)?			# 4: subseconds		(var)
+		(\s[-+]\\d{4})?			# 5: tz-offset		 6
+		(\s\\[\\d+\\])?			# 6: pid		(var)
 		/ox;
+    $offset = 19;
 
     $tod = defined($5) ?  $1 . $5 : $1;
     ($m_hour,$m_min) = ($2,$3);
 
+    # watch for subsecond precision
+    if (defined($4)) {
+      $offset += length($4);
+      next if ($length < 19 + $offset);
+    }
+
     # PH - watch for GMT offsets in the timestamp.
     if (defined($5)) {
-      $extra = 6;
+      $offset += 6;
       next if ($length < 44);
-    }
-    else {
-      $extra = 0;
-    }
-
-    # watch for subsecond precision
-    if (defined($4)) {
-      $extra += length($4);
-      next if ($length < 38 + $extra);
+      next if ($length < 19 + $offset);
     }
 
     # PH - watch for PID added after the timestamp.
     if (defined($6)) {
-      $extra += length($6);
-      next if ($length < 38 + $extra);
+      $offset += length($6);
+      next if ($length < 19 + $offset);
     }
 
-    # jgh 2025/09/30 - I really dislike this magic "20" offset...
-    # It would be better to develop it from the substrings captured so far.
+    # skip space after the initial groups
+    $offset++;
 
-    # $id = substr($_, 20 + $extra, 16);	# old ID was 16 chars
-    $id = substr($_, 20 + $extra, 23);		# new ID is 23 chars
+    $id = substr($_, $offset, 23);		# new ID is 23 chars, old 16
     $id =~ s/(\S+).*/$1/;
-    #
-    # jgh 2025/09/30 - very fragile when this word was not an ID;
-    # could be shorter than 16.
-    $extra += length($id) - 16;
 
-    # 37 = 20+16+1     so next field after ID.  Assuming there was really an ID.
-    $flag = substr($_, 37 + $extra, 2);
+    # skip ID and space
+    $offset += length($id) + 1;
+
+    $flag = substr($_, $offset, 2);
 
     # jgh 2025/09/30 -
-    # 2020-05-12 17:31:41.630 [23229] auth_login authenticator failed for (User) [185.143.75.81]:28556 I=[192.168.56.110]:25: 535 Incorrect authentication data (set_id=dropped@kiev.ua)
-    # OTOH the "refused" and "dropped" probably are referring to connectios
-    # rather than messages.
+    # 2020-05-12 17:31:41.630 [23229] auth_login authenticator failed for (User) [185.143.75.81]:28556 I=[192.168.56.110]:25: 535 Incorrect authentication data (set_id=dropped@foo.us)
+    # We now count these as cause for connection-drop, since the client often
+    # does on getting an auth-fail (distributed password-guessing attacks...).
     #
     # The "[-<>=*(]+" will be for ignoring accept & delivery lines.
     # What is the "SA"?  SpamAssissin ?
     if ($flag !~ /^([-<>=*(]+|SA)$/ && / (rejected|refused|dropped|authenticator failed)/) {
       $flag = "Re";
-      $extra -= 3;
+    } else {
+      # skip flag and space
+      $offset += 3;
     }
 
     # Rejects might have no MSGID...
-    # Note that $extra can go negative here.  Really, a $offset would be
-    # much more clear.
     if ($flag eq "Re" && $id !~ /^[-0-9a-zA-Z]+$/) {
-      $extra -= length($id) + 1;
+      $offset -= length($id) + 1;
       $id   = "reject:" . ++$rej_id;
     }
 ';
@@ -1947,11 +1943,13 @@ sub generate_parser {
   }
 
   $parser .= '
-    next unless ($flag =~ /<=|=>|->|==|\\*\\*|Co|SA|Re/);
+    next unless ($flag =~ /<=|\(=|=>|->|==|\\*\\*|Co|SA|Re/);
+
+    # TODO: handling for fakereject [ flag (= ]
 
-    #Strip away the timestamp, ID and flag to speed up later pattern matches.
-    #The flags include Co (Completed), Re (Rejected), and SA (SpamAssassin).
-    $_ = substr($_, 40 + $extra);  # PH
+    # Strip away the timestamp, ID and flag to speed up later pattern matches.
+    # The flags include Co (Completed), Re (Rejected), and SA (SpamAssassin).
+    $_ = substr($_, $offset);  # PH
 
     # Alias @message to the array of information about the message.
     # This minimises the number of calls to hash functions.
diff --git a/src/src/utils/exipick.src b/src/src/utils/exipick.src
index c441936a2..788f7efae 100644
--- a/src/src/utils/exipick.src
+++ b/src/src/utils/exipick.src
@@ -941,8 +941,6 @@ sub _parse_header {
     } elsif ($tag eq '-spam_score_int') {
       $self->{_vars}{spam_score_int} = $arg;
       $self->{_vars}{spam_score}     = $arg / 10;
-    } elsif ($tag eq '-bmi_verdicts') {
-      $self->{_vars}{bmi_verdicts} = $arg;
     } elsif ($tag eq '-host_lookup_deferred') {
       $self->{_vars}{host_lookup_deferred} = 1;
     } elsif ($tag eq '-host_lookup_failed') {
@@ -1569,10 +1567,6 @@ The value of AUTH= param for smtp messages, or a generated value from the callin
 
 Value of the header(s) with the same name with any RFC2047 words decoded if present.  See section 11.5 of Exim's spec.txt for full details.
 
-=item S + B<$bmi_verdicts>
-
-The verdict string provided by a Brightmail content scan
-
 =item N . B<$body_linecount>
 
 The number of lines in the message's body.
